//-----------------------------------------------------------------------------
// 
// 		cwCu		Androidp͏vO
// 
//  	Ver 3.18c
// 
//-----------------------------------------------------------------------------

// cwCu쐬p`
#define __DX_MAKE

#include "../DxCompileConfig.h"

#ifndef DX_NON_INPUT

// CN[h----------------------------------------------------------------
#include "DxInputAndroid.h"
#include "DxSystemAndroid.h"
#include "../DxLog.h"
#include "../DxInput.h"
#include "../DxSystem.h"

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N`------------------------------------------------------------------

#define DEADZONE							(DWORD)( 0.35 * 65536 )
#define DEADZONE_XINPUT( ZONE )				(short)( 32767 * (ZONE) / 65536)
#define DEADZONE_XINPUT_TRIGGER( ZONE )		(short)(   255 * (ZONE) / 65536)
#define VALIDRANGE_XINPUT( ZONE )			( 32767 - DEADZONE_XINPUT(ZONE))
#define VALIDRANGE_XINPUT_TRIGGER( ZONE )	(   255 - DEADZONE_XINPUT_TRIGGER(ZONE))

// ^`----------------------------------------------------------------------

// 萔` ----------------------------------------------------------------------

// f[^錾------------------------------------------------------------------

const static int32_t g_AndroidInputSourceTable[ ANDR_INPUT_SOURCE_NUM ] =
{
	AINPUT_SOURCE_UNKNOWN,
	AINPUT_SOURCE_KEYBOARD,
	AINPUT_SOURCE_DPAD,
	AINPUT_SOURCE_GAMEPAD,
	AINPUT_SOURCE_TOUCHSCREEN,
	AINPUT_SOURCE_MOUSE,
	AINPUT_SOURCE_STYLUS,
	AINPUT_SOURCE_TRACKBALL,
	AINPUT_SOURCE_TOUCHPAD,
	AINPUT_SOURCE_TOUCH_NAVIGATION,
	AINPUT_SOURCE_JOYSTICK,
} ;

const static unsigned short g_AndroidKeyToDXInputKey[][ 2 /* 0:AndroidL[R[h  1:DirectInputL[R[h  */ ] =
{
	{ AKEYCODE_A,				KEY_INPUT_A },			// `L[
	{ AKEYCODE_B,				KEY_INPUT_B },			// aL[
	{ AKEYCODE_C,				KEY_INPUT_C },			// bL[
	{ AKEYCODE_D,				KEY_INPUT_D },			// cL[
	{ AKEYCODE_E,				KEY_INPUT_E },			// dL[
	{ AKEYCODE_F,				KEY_INPUT_F },			// eL[
	{ AKEYCODE_G,				KEY_INPUT_G },			// fL[
	{ AKEYCODE_H,				KEY_INPUT_H },			// gL[
	{ AKEYCODE_I,				KEY_INPUT_I },			// hL[
	{ AKEYCODE_J,				KEY_INPUT_J },			// iL[
	{ AKEYCODE_K,				KEY_INPUT_K },			// jL[
	{ AKEYCODE_L,				KEY_INPUT_L },			// kL[
	{ AKEYCODE_M,				KEY_INPUT_M },			// lL[
	{ AKEYCODE_N,				KEY_INPUT_N },			// mL[
	{ AKEYCODE_O,				KEY_INPUT_O },			// nL[
	{ AKEYCODE_P,				KEY_INPUT_P },			// oL[
	{ AKEYCODE_Q,				KEY_INPUT_Q },			// pL[
	{ AKEYCODE_R,				KEY_INPUT_R },			// qL[
	{ AKEYCODE_S,				KEY_INPUT_S },			// rL[
	{ AKEYCODE_T,				KEY_INPUT_T },			// sL[
	{ AKEYCODE_U,				KEY_INPUT_U },			// tL[
	{ AKEYCODE_V,				KEY_INPUT_V },			// uL[
	{ AKEYCODE_W,				KEY_INPUT_W },			// vL[
	{ AKEYCODE_X,				KEY_INPUT_X },			// wL[
	{ AKEYCODE_Y,				KEY_INPUT_Y },			// xL[
	{ AKEYCODE_Z,				KEY_INPUT_Z },			// yL[
	{ AKEYCODE_0,				KEY_INPUT_0 },			// OL[
	{ AKEYCODE_1,				KEY_INPUT_1 },			// PL[
	{ AKEYCODE_2,				KEY_INPUT_2 },			// QL[
	{ AKEYCODE_3,				KEY_INPUT_3 },			// RL[
	{ AKEYCODE_4,				KEY_INPUT_4 },			// SL[
	{ AKEYCODE_5,				KEY_INPUT_5 },			// TL[
	{ AKEYCODE_6,				KEY_INPUT_6 },			// UL[
	{ AKEYCODE_7,				KEY_INPUT_7 },			// VL[
	{ AKEYCODE_8,				KEY_INPUT_8 },			// WL[
	{ AKEYCODE_9,				KEY_INPUT_9 },			// XL[

	{ AKEYCODE_DPAD_LEFT,		KEY_INPUT_LEFT },		// L[
	{ AKEYCODE_DPAD_UP,			KEY_INPUT_UP },			// L[
	{ AKEYCODE_DPAD_RIGHT,		KEY_INPUT_RIGHT },		// EL[
	{ AKEYCODE_DPAD_DOWN,		KEY_INPUT_DOWN },		// L[

	{ AKEYCODE_SEMICOLON,		KEY_INPUT_SEMICOLON },	// GL[
	{ AKEYCODE_LEFT_BRACKET,	KEY_INPUT_LBRACKET },	// mL[
	{ AKEYCODE_RIGHT_BRACKET,	KEY_INPUT_RBRACKET },	// nL[
	{ AKEYCODE_AT,				KEY_INPUT_AT },			// L[
	{ AKEYCODE_COMMA,			KEY_INPUT_COMMA },		// CL[

	{ AKEYCODE_MINUS,			KEY_INPUT_MINUS },		// |L[
	{ AKEYCODE_BACKSLASH,		KEY_INPUT_YEN },		// L[
	{ AKEYCODE_PERIOD,			KEY_INPUT_PERIOD },		// DL[
	{ AKEYCODE_SLASH,			KEY_INPUT_SLASH },		// ^L[

	{ AKEYCODE_DEL,				KEY_INPUT_DELETE },		// f[gL[

	{ AKEYCODE_BACK,			KEY_INPUT_ESCAPE },		// GXP[vL[
	{ AKEYCODE_SPACE,			KEY_INPUT_SPACE },		// Xy[XL[

	{ AKEYCODE_TAB, 			KEY_INPUT_TAB },		// ^uL[
	{ AKEYCODE_ENTER,			KEY_INPUT_RETURN },		// G^[L[
	{ AKEYCODE_HOME,			KEY_INPUT_HOME },		// z[L[

	{ 0xffff,					0xffff },
} ;

// ֐vg^Cv錾 -------------------------------------------------------

// vO------------------------------------------------------------------

// ̓VXe鏈̊ˑ
extern int InitializeInputSystem_PF_Timing0( void )
{
	static int NowInitialize = FALSE ;
	int i, j ;

	// ɏJnĂꍇɏI
	if( NowInitialize )
	{
		return 0 ;
	}

	// tO𗧂Ă
	NowInitialize = TRUE ;

	// ][̃Zbg
	for( i = 0 ; i < MAX_JOYPAD_NUM ; i ++ )
	{
		InputSysData.Pad[ i ].DeadZone = DEADZONE ;
	}

	// L[{[hƃWCpbh̓͂̃ftHg̑Ή\ݒ肷
	if( InputSysData.KeyToJoypadInputInitializeFlag == FALSE )
	{
		InputSysData.KeyToJoypadInputInitializeFlag = TRUE ;

		for( i = 0 ; i < MAX_JOYPAD_NUM ; i ++ )
		{
			for ( j = 0 ; j < 32 ; j ++ )
			{
				InputSysData.KeyToJoypadInput[ i ][ j ][ 0 ] = -1 ;
				InputSysData.KeyToJoypadInput[ i ][ j ][ 1 ] = -1 ;
			}
		}
		InputSysData.KeyToJoypadInput[ 0 ][  0 ][ 0 ] = KEY_INPUT_NUMPAD2 ;
		InputSysData.KeyToJoypadInput[ 0 ][  0 ][ 1 ] = KEY_INPUT_DOWN ;
		InputSysData.KeyToJoypadInput[ 0 ][  1 ][ 0 ] = KEY_INPUT_NUMPAD4 ;
		InputSysData.KeyToJoypadInput[ 0 ][  1 ][ 1 ] = KEY_INPUT_LEFT ;
		InputSysData.KeyToJoypadInput[ 0 ][  2 ][ 0 ] = KEY_INPUT_NUMPAD6 ;
		InputSysData.KeyToJoypadInput[ 0 ][  2 ][ 1 ] = KEY_INPUT_RIGHT ;
		InputSysData.KeyToJoypadInput[ 0 ][  3 ][ 0 ] = KEY_INPUT_NUMPAD8 ;
		InputSysData.KeyToJoypadInput[ 0 ][  3 ][ 1 ] = KEY_INPUT_UP ;
		InputSysData.KeyToJoypadInput[ 0 ][  4 ][ 0 ] = KEY_INPUT_Z ;
		InputSysData.KeyToJoypadInput[ 0 ][  5 ][ 0 ] = KEY_INPUT_X ;
		InputSysData.KeyToJoypadInput[ 0 ][  6 ][ 0 ] = KEY_INPUT_C ;
		InputSysData.KeyToJoypadInput[ 0 ][  7 ][ 0 ] = KEY_INPUT_A ;
		InputSysData.KeyToJoypadInput[ 0 ][  8 ][ 0 ] = KEY_INPUT_S ;
		InputSysData.KeyToJoypadInput[ 0 ][  9 ][ 0 ] = KEY_INPUT_D ;
		InputSysData.KeyToJoypadInput[ 0 ][ 10 ][ 0 ] = KEY_INPUT_Q ;
		InputSysData.KeyToJoypadInput[ 0 ][ 11 ][ 0 ] = KEY_INPUT_W ;
		InputSysData.KeyToJoypadInput[ 0 ][ 12 ][ 0 ] = KEY_INPUT_RETURN ;
		InputSysData.KeyToJoypadInput[ 0 ][ 13 ][ 0 ] = KEY_INPUT_SPACE ;
	}

	InputSysData.PF.UseInputInfoNum = 0 ;

	// tO|
	NowInitialize = FALSE ;

	// I
	return 0 ;
}

// ̓VXěn鏈̊ˑ
extern int TerminateInputSystem_PF_Timing0( void )
{
	// I
	return 0 ;
}

// sˑ
extern int AutoInitialize_PF( void )
{
	return 0 ;
}

// WCpbh̃ZbgAbv̊ˑ
extern int SetupJoypad_PF( void )
{
	// I
	return 0 ;
}

// WCpbȟns̊ˑ
extern int TerminateJoypad_PF( void )
{
	// I
	return 0 ;
}

// ͏Ԃ̍XV̊ˑ
extern int UpdateKeyboardInputState_PF( int UseProcessMessage )
{
	_MEMSET( &InputSysData.KeyInputBuf, 0, sizeof( InputSysData.KeyInputBuf ) ) ;
	if( InputSysData.PF.SourceNum[ ANDR_INPUT_SOURCE_KEYBOARD ] > 0 )
	{
		int i, j ;

		for( j = 0 ; j < InputSysData.PF.SourceNum[ ANDR_INPUT_SOURCE_KEYBOARD ] ; j ++ )
		{
			INPUT_ANDROID_DEVICE_INFO *Info = &InputSysData.PF.InputInfo[ InputSysData.PF.SourceNoToInputInfoTable[ ANDR_INPUT_SOURCE_KEYBOARD ][ j ] ] ;

			for( i = 0 ; g_AndroidKeyToDXInputKey[i][0] != 0xffff ; i ++ )
			{
				InputSysData.KeyInputBuf[ g_AndroidKeyToDXInputKey[ i ][ 1 ] ] |= Info->KeyState[ g_AndroidKeyToDXInputKey[ i ][ 0 ] ] ? 0x80 : 0x00 ;
			}
		}
	}

	return 0 ;
}

// pbh̓͏Ԃ̍XV̊ˑ
extern int UpdateJoypadInputState_PF( int PadNo )
{
	INPUTPADDATA *pad = &InputSysData.Pad[ PadNo ] ;
//	INPUT_ANDROID_DEVICE_INFO *Info = &InputSysData.PF.InputInfo[ InputSysData.PF.SourceNoToInputInfoTable[ ANDR_INPUT_SOURCE_GAMEPAD ][ PadNo ] ] ;
	INPUT_ANDROID_DEVICE_INFO *Info = &InputSysData.PF.InputInfo[ InputSysData.PF.GamePadSourceNoToInputInfoTable[ PadNo ] ] ;
	float DeadZone = pad->DeadZone / 65536.0f ;

//	if( InputSysData.PF.SourceNum[ ANDR_INPUT_SOURCE_GAMEPAD ] <= 0 )
	if( InputSysData.PF.GamePadSourceNum <= 0 )
	{
		return 0 ;
	}

	pad->State.X  = Info->AxisX  < DeadZone && Info->AxisX  > -DeadZone ? 0 : ( int )( Info->AxisX  * 1000.0f ) ;
	pad->State.Y  = Info->AxisY  < DeadZone && Info->AxisY  > -DeadZone ? 0 : ( int )( Info->AxisY  * 1000.0f ) ;
	pad->State.Z  = Info->AxisZ  < DeadZone && Info->AxisZ  > -DeadZone ? 0 : ( int )( Info->AxisZ  * 1000.0f ) ;
	pad->State.Rx = Info->AxisRx < DeadZone && Info->AxisRx > -DeadZone ? 0 : ( int )( Info->AxisRx * 1000.0f ) ;
	pad->State.Ry = Info->AxisRy < DeadZone && Info->AxisRy > -DeadZone ? 0 : ( int )( Info->AxisRy * 1000.0f ) ;
	pad->State.Rz = Info->AxisRz < DeadZone && Info->AxisRz > -DeadZone ? 0 : ( int )( Info->AxisRz * 1000.0f ) ;
	pad->State.Slider[ 0 ]   = ( int )( Info->AxisLTrigger * 1000.0f ) ;
	pad->State.Slider[ 1 ]   = ( int )( Info->AxisRTrigger * 1000.0f ) ;
	if( Info->AxisHatX > 0.5f )
	{
		if( Info->AxisHatY > 0.5f )
		{
			pad->State.POV[ 0 ] = 13500 ;
		}
		else
		if( Info->AxisHatY < -0.5f )
		{
			pad->State.POV[ 0 ] = 4500 ;
		}
		else
		{
			pad->State.POV[ 0 ] = 9000 ;
		}
	}
	else
	if( Info->AxisHatX < -0.5f )
	{
		if( Info->AxisHatY > 0.5f )
		{
			pad->State.POV[ 0 ] = 22500 ;
		}
		else
		if( Info->AxisHatY < -0.5f )
		{
			pad->State.POV[ 0 ] = 31500 ;
		}
		else
		{
			pad->State.POV[ 0 ] = 27000 ;
		}
	}
	else
	{
		if( Info->AxisHatY > 0.5f )
		{
			pad->State.POV[ 0 ] = 18000 ;
		}
		else
		if( Info->AxisHatY < -0.5f )
		{
			pad->State.POV[ 0 ] = 0 ;
		}
		else
		{
			pad->State.POV[ 0 ] = 0xffffffff ;
		}
	}
	pad->State.POV[ 1 ]      = 0xffffffff ;
	pad->State.POV[ 2 ]      = 0xffffffff ;
	pad->State.POV[ 3 ]      = 0xffffffff ;
	pad->State.Buttons[  0 ] = Info->KeyState[ AKEYCODE_BUTTON_A      ] ? 0x80 : 0x00 ;
	pad->State.Buttons[  1 ] = Info->KeyState[ AKEYCODE_BUTTON_B      ] ? 0x80 : 0x00 ;
	pad->State.Buttons[  2 ] = Info->KeyState[ AKEYCODE_BUTTON_X      ] ? 0x80 : 0x00 ;
	pad->State.Buttons[  3 ] = Info->KeyState[ AKEYCODE_BUTTON_Y      ] ? 0x80 : 0x00 ;
	pad->State.Buttons[  4 ] = Info->KeyState[ AKEYCODE_BUTTON_L1     ] ? 0x80 : 0x00 ;
	pad->State.Buttons[  5 ] = Info->KeyState[ AKEYCODE_BUTTON_R1     ] ? 0x80 : 0x00 ;
	pad->State.Buttons[  6 ] = Info->KeyState[ AKEYCODE_BUTTON_L2     ] ? 0x80 : 0x00 ;
	pad->State.Buttons[  7 ] = Info->KeyState[ AKEYCODE_BUTTON_R2     ] ? 0x80 : 0x00 ;
	pad->State.Buttons[  8 ] = Info->KeyState[ AKEYCODE_BUTTON_THUMBL ] ? 0x80 : 0x00 ;
	pad->State.Buttons[  9 ] = Info->KeyState[ AKEYCODE_BUTTON_THUMBR ] ? 0x80 : 0x00 ;
	pad->State.Buttons[ 10 ] = Info->KeyState[ AKEYCODE_BUTTON_SELECT ] ? 0x80 : 0x00 ;
	pad->State.Buttons[ 11 ] = Info->KeyState[ AKEYCODE_BUTTON_START  ] ? 0x80 : 0x00 ;
	pad->State.Buttons[ 12 ] = 0 ;
	pad->State.Buttons[ 13 ] = 0 ;
	pad->State.Buttons[ 14 ] = 0 ;
	pad->State.Buttons[ 15 ] = 0 ;
	pad->State.Buttons[ 16 ] = 0 ;
	pad->State.Buttons[ 17 ] = 0 ;
	pad->State.Buttons[ 18 ] = 0 ;
	pad->State.Buttons[ 19 ] = 0 ;
	pad->State.Buttons[ 20 ] = 0 ;
	pad->State.Buttons[ 21 ] = 0 ;
	pad->State.Buttons[ 22 ] = 0 ;
	pad->State.Buttons[ 23 ] = 0 ;
	pad->State.Buttons[ 24 ] = 0 ;
	pad->State.Buttons[ 25 ] = 0 ;
	pad->State.Buttons[ 26 ] = 0 ;
	pad->State.Buttons[ 27 ] = 0 ;
	pad->State.Buttons[ 28 ] = 0 ;
	pad->State.Buttons[ 29 ] = 0 ;
	pad->State.Buttons[ 30 ] = 0 ;
	pad->State.Buttons[ 31 ] = 0 ;

//	if( Info->KeyState[ AKEYCODE_DPAD_LEFT  ] != 0 ) pad->State.X = -1000 ;
//	if( Info->KeyState[ AKEYCODE_DPAD_RIGHT ] != 0 ) pad->State.X =  1000 ;
//	if( Info->KeyState[ AKEYCODE_DPAD_UP    ] != 0 ) pad->State.Y = -1000 ;
//	if( Info->KeyState[ AKEYCODE_DPAD_DOWN  ] != 0 ) pad->State.Y =  1000 ;
//
//	if( Info->KeyState[ AKEYCODE_J          ] != 0 ) pad->State.Z  = -1000 ;
//	if( Info->KeyState[ AKEYCODE_L          ] != 0 ) pad->State.Z  =  1000 ;
//	if( Info->KeyState[ AKEYCODE_I          ] != 0 ) pad->State.Rz = -1000 ;
//	if( Info->KeyState[ AKEYCODE_K          ] != 0 ) pad->State.Rz =  1000 ;
//
//	if( Info->KeyState[ AKEYCODE_2          ] != 0 ) pad->State.Buttons[  0 ] = 0x80 ;
//	if( Info->KeyState[ AKEYCODE_3          ] != 0 ) pad->State.Buttons[  1 ] = 0x80 ;
//	if( Info->KeyState[ AKEYCODE_1          ] != 0 ) pad->State.Buttons[  2 ] = 0x80 ;
//	if( Info->KeyState[ AKEYCODE_4          ] != 0 ) pad->State.Buttons[  3 ] = 0x80 ;
//	if( Info->KeyState[ AKEYCODE_5          ] != 0 ) pad->State.Buttons[  4 ] = 0x80 ;
//	if( Info->KeyState[ AKEYCODE_6          ] != 0 ) pad->State.Buttons[  5 ] = 0x80 ;
//	if( Info->KeyState[ AKEYCODE_7          ] != 0 ) pad->State.Buttons[  6 ] = 0x80 ;
//	if( Info->KeyState[ AKEYCODE_8          ] != 0 ) pad->State.Buttons[  7 ] = 0x80 ;
//	if( Info->KeyState[ AKEYCODE_9          ] != 0 ) pad->State.Buttons[  8 ] = 0x80 ;
//	if( Info->KeyState[ AKEYCODE_0          ] != 0 ) pad->State.Buttons[  9 ] = 0x80 ;
//
//	if( Info->KeyState[ AKEYCODE_DEL        ] != 0 ) pad->State.Buttons[ 10 ] = 0x80 ;
//	if( Info->KeyState[ AKEYCODE_ENTER      ] != 0 ) pad->State.Buttons[ 11 ] = 0x80 ;
//
//	if( Info->KeyState[ AKEYCODE_D ] )
//	{
//		if( Info->KeyState[ AKEYCODE_S ] )
//		{
//			pad->State.POV[ 0 ] = 13500 ;
//		}
//		else
//		if( Info->KeyState[ AKEYCODE_W ] )
//		{
//			pad->State.POV[ 0 ] = 4500 ;
//		}
//		else
//		{
//			pad->State.POV[ 0 ] = 9000 ;
//		}
//	}
//	else
//	if( Info->KeyState[ AKEYCODE_A ] )
//	{
//		if( Info->KeyState[ AKEYCODE_S ] )
//		{
//			pad->State.POV[ 0 ] = 22500 ;
//		}
//		else
//		if( Info->KeyState[ AKEYCODE_W ] )
//		{
//			pad->State.POV[ 0 ] = 31500 ;
//		}
//		else
//		{
//			pad->State.POV[ 0 ] = 27000 ;
//		}
//	}
//	else
//	{
//		if( Info->KeyState[ AKEYCODE_S ] )
//		{
//			pad->State.POV[ 0 ] = 18000 ;
//		}
//		else
//		if( Info->KeyState[ AKEYCODE_W ] )
//		{
//			pad->State.POV[ 0 ] = 0 ;
//		}
//	}

	// I
	return 0 ;
}

// pbhGtFNg̍ĐԂXV֐̊ˑ
extern int RefreshEffectPlayState_PF( void )
{
	// I
	return 0 ;
}

// w̃pbhUɑΉĂ邩ǂ擾( TRUE:ΉĂ  FALSE:ΉĂȂ )
extern int CheckJoypadVibrationEnable_PF( INPUTPADDATA *pad, int EffectIndex )
{
	return FALSE ;
}

// w̓̓foCX XInput ɑΉĂ邩ǂ擾鏈̊ˑ( ߂l  TRUE:XInputΉ̓̓foCX  FALSE:XInputΉ̓̓foCX   -1:G[ )( DX_INPUT_KEY  DX_INPUT_KEY_PAD1 ȂǁAL[{[hރ^Cv InputType ɓnƃG[ƂȂ -1 Ԃ )̊ˑ
extern int CheckJoypadXInput_PF( int InputType )
{
	return FALSE ;
}

// }EX̃{^̏Ԃ𓾂鏈̊ˑ
extern int GetMouseInput_PF( void )
{
	int res = 0 ;

	if( InputSysData.PF.SourceNum[ ANDR_INPUT_SOURCE_MOUSE ] > 0 )
	{
		INPUT_ANDROID_DEVICE_INFO *Info = &InputSysData.PF.InputInfo[ InputSysData.PF.SourceNoToInputInfoTable[ ANDR_INPUT_SOURCE_MOUSE ][ 0 ] ] ;

		if( ( Info->ButtonState & 0x01 ) != 0 ) res |= MOUSE_INPUT_1 ;
		if( ( Info->ButtonState & 0x02 ) != 0 ) res |= MOUSE_INPUT_2 ;
		if( ( Info->ButtonState & 0x04 ) != 0 ) res |= MOUSE_INPUT_3 ;
		if( ( Info->ButtonState & 0x08 ) != 0 ) res |= MOUSE_INPUT_4 ;
		if( ( Info->ButtonState & 0x10 ) != 0 ) res |= MOUSE_INPUT_5 ;
		if( ( Info->ButtonState & 0x20 ) != 0 ) res |= MOUSE_INPUT_6 ;
		if( ( Info->ButtonState & 0x40 ) != 0 ) res |= MOUSE_INPUT_7 ;
		if( ( Info->ButtonState & 0x80 ) != 0 ) res |= MOUSE_INPUT_8 ;
	}

	return res ;
}

// }EẌʒu擾
extern int GetMousePoint_PF( int *XBuf, int *YBuf )
{
	if( XBuf != NULL )
	{
		*XBuf = 0 ;
	}

	if( YBuf != NULL )
	{
		*YBuf = 0 ;
	}

	if( InputSysData.PF.SourceNum[ ANDR_INPUT_SOURCE_MOUSE ] > 0 )
	{
		int ScreenX, ScreenY ;
		INPUT_ANDROID_DEVICE_INFO *Info = &InputSysData.PF.InputInfo[ InputSysData.PF.SourceNoToInputInfoTable[ ANDR_INPUT_SOURCE_MOUSE ][ 0 ] ] ;

		ScreenX = ( int )Info->AxisX ;
		ScreenY = ( int )Info->AxisY ;
		ConvScreenPositionToDxScreenPosition( ScreenX, ScreenY, XBuf, YBuf ) ;
	}

	return 0 ;
}

// }EẌʒuZbg
extern int SetMousePoint_PF( int PointX , int PointY )
{
	return 0 ;
}

// WCpbh̖][̐ݒs֐̊ˑ
extern int SetJoypadDeadZone_PF( INPUTPADDATA *pad )
{
	// I
	return 0 ;
}

// foCXhclׂ͏ԍ擾
extern int GetAndroidDeviceIdToInputInfoNo( int32_t Source, int32_t DeviceId )
{
	int i ;
//	int Src ;
//
//	for( Src = 0 ; Src < ANDR_INPUT_SOURCE_NUM ; Src ++ )
//	{
//		if( g_AndroidInputSourceTable[ Src ] == Source )
//		{
//			break ;
//		}
//	}
//	if( Src == ANDR_INPUT_SOURCE_NUM )
//	{
//		return -1 ;
//	}

	for( i = 0 ; i < InputSysData.PF.UseInputInfoNum ; i ++ )
	{
		if( /* InputSysData.PF.InputInfo[ i ].Source   == Source   && */
			   InputSysData.PF.InputInfo[ i ].DeviceId == DeviceId )
		{
			int UpdateFlag = FALSE ;

			if( ( InputSysData.PF.InputInfo[ i ].Source & Source ) != Source )
			{
				UpdateFlag = TRUE ;
			}

			InputSysData.PF.InputInfo[ i ].Source |= Source ;
			InputSysData.PF.InputInfo[ i ].UpdateCount = InputSysData.PF.UpdateCount ;
			InputSysData.PF.UpdateCount ++ ;

			if( UpdateFlag )
			{
				RefreshAndroidSourceNoToInputInfoTable( Source ) ;
				RefreshAndroidGamePadSourceNoToInputInfoTable() ;
			}
			return i ;
		}
	}

	if( InputSysData.PF.UseInputInfoNum == ANDR_DEVICE_MAX_NUM )
	{
		int MinUpdateCountNo ;

		MinUpdateCountNo = 0 ;
		for( i = 1 ; i < InputSysData.PF.UseInputInfoNum ; i ++ )
		{
			if( InputSysData.PF.InputInfo[ MinUpdateCountNo ].UpdateCount > InputSysData.PF.InputInfo[ i ].UpdateCount )
			{
				MinUpdateCountNo = i ;
			}
		}

		_MEMSET( &InputSysData.PF.InputInfo[ MinUpdateCountNo ], 0, sizeof( InputSysData.PF.InputInfo[ MinUpdateCountNo ] ) ) ;
		InputSysData.PF.InputInfo[ MinUpdateCountNo ].Source = Source ;
		InputSysData.PF.InputInfo[ MinUpdateCountNo ].DeviceId = DeviceId ;
		InputSysData.PF.InputInfo[ MinUpdateCountNo ].UpdateCount = InputSysData.PF.UpdateCount ;
		InputSysData.PF.UpdateCount ++ ;

		RefreshAndroidSourceNoToInputInfoTable( Source ) ;
		RefreshAndroidGamePadSourceNoToInputInfoTable() ;

		return MinUpdateCountNo ;
	}

	i = InputSysData.PF.UseInputInfoNum ;
	InputSysData.PF.UseInputInfoNum ++ ;

	_MEMSET( &InputSysData.PF.InputInfo[ i ], 0, sizeof( InputSysData.PF.InputInfo[ i ] ) ) ;
	InputSysData.PF.InputInfo[ i ].Source = Source ;
	InputSysData.PF.InputInfo[ i ].DeviceId = DeviceId ;
	InputSysData.PF.InputInfo[ i ].UpdateCount = InputSysData.PF.UpdateCount ;
	InputSysData.PF.UpdateCount ++ ;

	RefreshAndroidSourceNoToInputInfoTable( Source ) ;
	RefreshAndroidGamePadSourceNoToInputInfoTable() ;
	
	return i ;
}

// ̓\[XԍƓ͏Ƃ̑Ήe[uXV
extern int RefreshAndroidSourceNoToInputInfoTable( int32_t Source )
{
	INPUT_ANDROID_DEVICE_INFO *Info ;
	int *SourceNoTable ;
	int i, j ;
	int Num ;
	int NoTable[ ANDR_DEVICE_MAX_NUM ] ;
	INPUT_ANDROID_DEVICE_INFO *InfoTable[ ANDR_DEVICE_MAX_NUM ] ;
	int Src ;

	for( Src = 0 ; Src < ANDR_INPUT_SOURCE_NUM ; Src ++ )
	{
		if( Source == g_AndroidInputSourceTable[ Src ] )
		{
			break ;
		}
	}
	if( Src == ANDR_INPUT_SOURCE_NUM )
	{
		return -1 ;
	}

	Num = 0 ;
	Info = InputSysData.PF.InputInfo ;
	for( i = 0 ; i < InputSysData.PF.UseInputInfoNum ; i ++, Info ++ )
	{
		if( ( Info->Source & Source ) == Source )
		{
			InfoTable[ Num ] = Info ;
			Num ++ ;
		}
	}
	InputSysData.PF.SourceNum[ Src ] = Num ;

	if( Num == 0 )
	{
		return 0 ;
	}

	NoTable[ 0 ] = 0 ;
	for( i = 1 ; i < Num ; i ++ )
	{
		for( j = 0 ; j < i ; j ++ )
		{
			if( InfoTable[ NoTable[ j ] ]->DeviceId < InfoTable[ i ]->DeviceId )
			{
				_MEMMOVE( &NoTable[ j + 1 ], &NoTable[ j ], sizeof( int ) * ( i - j ) ) ;
				NoTable[ j ] = i ;
				break ;
			}
		}
		if( j == i )
		{
			NoTable[ j ] = i ;
		}
	}

	SourceNoTable = InputSysData.PF.SourceNoToInputInfoTable[ Src ] ;
	for( i = 0 ; i < Num ; i ++ )
	{
		SourceNoTable[ i ] = InfoTable[ NoTable[ i ] ] - InputSysData.PF.InputInfo ;
	}

	// I
	return 0 ;
}

// Q[pbh̔ԍƓ͏Ƃ̑Ήe[uXV
extern int RefreshAndroidGamePadSourceNoToInputInfoTable( void )
{
	INPUT_ANDROID_DEVICE_INFO *Info ;
	int *SourceNoTable ;
	int i, j ;
	int Num ;
	int NoTable[ ANDR_DEVICE_MAX_NUM ] ;
	INPUT_ANDROID_DEVICE_INFO *InfoTable[ ANDR_DEVICE_MAX_NUM ] ;

	Num = 0 ;
	Info = InputSysData.PF.InputInfo ;
	for( i = 0 ; i < InputSysData.PF.UseInputInfoNum ; i ++, Info ++ )
	{
		// cwCuQ[pbhƂĈvfĂꍇ̓Q[pbhƂ
		if( ( ( Info->Source & AINPUT_SOURCE_GAMEPAD  ) == AINPUT_SOURCE_GAMEPAD ) ||
			( ( Info->Source & AINPUT_SOURCE_JOYSTICK ) == AINPUT_SOURCE_JOYSTICK ) )
		{
			InfoTable[ Num ] = Info ;
			Num ++ ;
		}
	}
	InputSysData.PF.GamePadSourceNum = Num ;

	if( Num == 0 )
	{
		return 0 ;
	}

	NoTable[ 0 ] = 0 ;
	for( i = 1 ; i < Num ; i ++ )
	{
		for( j = 0 ; j < i ; j ++ )
		{
			if( InfoTable[ NoTable[ j ] ]->DeviceId < InfoTable[ i ]->DeviceId )
			{
				_MEMMOVE( &NoTable[ j + 1 ], &NoTable[ j ], sizeof( int ) * ( i - j ) ) ;
				NoTable[ j ] = i ;
				break ;
			}
		}
		if( j == i )
		{
			NoTable[ j ] = i ;
		}
	}

	SourceNoTable = InputSysData.PF.GamePadSourceNoToInputInfoTable ;
	for( i = 0 ; i < Num ; i ++ )
	{
		SourceNoTable[ i ] = InfoTable[ NoTable[ i ] ] - InputSysData.PF.InputInfo ;
	}

	InputSysData.PadNum = Num > MAX_JOYPAD_NUM ? MAX_JOYPAD_NUM : Num ;

	// I
	return 0 ;
}

// ̓Cxg
extern int32_t ProcessInputEvent( AInputEvent* event )
{
	int32_t InputType ;
	int32_t Source ;
	int32_t DeviceId ;
	int InputNo ;

	Source		= AInputEvent_getSource( event ) ;
	InputType	= AInputEvent_getType( event ) ;
	DeviceId	= AInputEvent_getDeviceId( event ) ;

	InputNo = GetAndroidDeviceIdToInputInfoNo( Source, DeviceId ) ;

	if( InputType == AINPUT_EVENT_TYPE_MOTION )
	{
		int32_t Action ;
		int32_t PIndex ;
		Action = AMotionEvent_getAction( event ) ;
		PIndex = ( Action & AMOTION_EVENT_ACTION_POINTER_INDEX_MASK ) >> AMOTION_EVENT_ACTION_POINTER_INDEX_SHIFT ;
		Action &= AMOTION_EVENT_ACTION_MASK ;

		if( ( Source & AINPUT_SOURCE_TOUCHSCREEN ) == AINPUT_SOURCE_TOUCHSCREEN )
		{
			TOUCHINPUTDATA TouchInputData ;
			int32_t PointerCount ;

			TouchInputData.PointNum = 0 ;
			TouchInputData.Time = ( LONGLONG )AMotionEvent_getEventTime( event ) ;

			if( Action != AMOTION_EVENT_ACTION_UP )
			{
				PointerCount = AMotionEvent_getPointerCount( event ) ;
				if( PointerCount > 0 )
				{
					int32_t i ;
					TOUCHINPUTPOINT *TouchPoint ;

					TouchPoint = TouchInputData.Point ;
					for( i = 0; i < PointerCount; i++ )
					{
						int ScreenX, ScreenY ;

						TouchPoint->Device = 0 ;
						TouchPoint->ID = AMotionEvent_getPointerId( event, i ) ;
						ScreenX = AMotionEvent_getX( event, i ) ;
						ScreenY = AMotionEvent_getY( event, i ) ;
						ConvScreenPositionToDxScreenPosition( ScreenX, ScreenY, &TouchPoint->PositionX, &TouchPoint->PositionY ) ;

						TouchInputData.PointNum ++ ;
						TouchPoint ++ ;
					}
				}
			}

			AddTouchInputData( &TouchInputData ) ;
		}

		if( ( Source & AINPUT_SOURCE_MOUSE ) == AINPUT_SOURCE_MOUSE )
		{
			if( Action == AMOTION_EVENT_ACTION_POINTER_DOWN )
			{
				InputSysData.PF.InputInfo[ InputNo ].PointerState[ PIndex ] = 1 ;
			}
			else
			if( Action == AMOTION_EVENT_ACTION_POINTER_UP )
			{
				InputSysData.PF.InputInfo[ InputNo ].PointerState[ PIndex ] = 0 ;
			}

			InputSysData.PF.InputInfo[ InputNo ].ButtonState	= AMotionEvent_getButtonState( event ) ;
			InputSysData.PF.InputInfo[ InputNo ].AxisX			= AMotionEvent_getAxisValue( event, AMOTION_EVENT_AXIS_X,			0 ) ;
			InputSysData.PF.InputInfo[ InputNo ].AxisY			= AMotionEvent_getAxisValue( event, AMOTION_EVENT_AXIS_Y,			0 ) ;
			InputSysData.PF.InputInfo[ InputNo ].Wheel			= AMotionEvent_getAxisValue( event, AMOTION_EVENT_AXIS_WHEEL,		0 ) ;
		}

		if( ( Source & AINPUT_SOURCE_JOYSTICK ) == AINPUT_SOURCE_JOYSTICK )
		{
			InputSysData.PF.InputInfo[ InputNo ].AxisX			= AMotionEvent_getAxisValue( event, AMOTION_EVENT_AXIS_X,			0 ) ;
			InputSysData.PF.InputInfo[ InputNo ].AxisY			= AMotionEvent_getAxisValue( event, AMOTION_EVENT_AXIS_Y,			0 ) ;
			InputSysData.PF.InputInfo[ InputNo ].AxisZ			= AMotionEvent_getAxisValue( event, AMOTION_EVENT_AXIS_Z,			0 ) ;
			InputSysData.PF.InputInfo[ InputNo ].AxisRx			= AMotionEvent_getAxisValue( event, AMOTION_EVENT_AXIS_RX,			0 ) ;
			InputSysData.PF.InputInfo[ InputNo ].AxisRy			= AMotionEvent_getAxisValue( event, AMOTION_EVENT_AXIS_RY,			0 ) ;
			InputSysData.PF.InputInfo[ InputNo ].AxisRz			= AMotionEvent_getAxisValue( event, AMOTION_EVENT_AXIS_RZ,			0 ) ;
			InputSysData.PF.InputInfo[ InputNo ].AxisHatX		= AMotionEvent_getAxisValue( event, AMOTION_EVENT_AXIS_HAT_X,		0 ) ;
			InputSysData.PF.InputInfo[ InputNo ].AxisHatY		= AMotionEvent_getAxisValue( event, AMOTION_EVENT_AXIS_HAT_Y,		0 ) ;
			InputSysData.PF.InputInfo[ InputNo ].AxisLTrigger	= AMotionEvent_getAxisValue( event, AMOTION_EVENT_AXIS_LTRIGGER,	0 ) ;
			InputSysData.PF.InputInfo[ InputNo ].AxisRTrigger	= AMotionEvent_getAxisValue( event, AMOTION_EVENT_AXIS_RTRIGGER,	0 ) ;
		}

		return 1 ;
	}
	else
	if( InputType == AINPUT_EVENT_TYPE_KEY )
	{
		int32_t Action ;
		int32_t KeyCode ;
		int32_t res = 1 ; 

		Action = AKeyEvent_getAction( event ) ;
		KeyCode = AKeyEvent_getKeyCode( event ) ;
		if( KeyCode < 256 )
		{
			if( Action == AKEY_EVENT_ACTION_DOWN )
			{
				InputSysData.PF.InputInfo[ InputNo ].KeyState[ KeyCode ] = 1 ;
			}
			else
			if( Action == AKEY_EVENT_ACTION_UP )
			{
				InputSysData.PF.InputInfo[ InputNo ].KeyState[ KeyCode ] = 0 ;
			}
		}

		if( KeyCode == AKEYCODE_VOLUME_UP   ||
			KeyCode == AKEYCODE_VOLUME_DOWN ||
			KeyCode == AKEYCODE_POWER       ||
			KeyCode == AKEYCODE_HOME        ||
			KeyCode == AKEYCODE_CAMERA )
		{
			res = 0 ;
		}

		return res ;
	}

	return 0 ;
}


#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // DX_NON_INPUT


