// -------------------------------------------------------------------------------
// 
// 		cwCu		AndroidpVXevOwb_t@C
// 
// 				Ver 3.18c
// 
// -------------------------------------------------------------------------------

#ifndef __DXSYSTEMANDROID_H__
#define __DXSYSTEMANDROID_H__

// CN[h ------------------------------------------------------------------
#include "../DxCompileConfig.h"
#include <android/configuration.h>
#include <android/looper.h>
#include <android/native_activity.h>
#include <android/sensor.h>
#include <poll.h>
#include <pthread.h>
#include <sched.h>
#include <EGL/egl.h>

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

// \tgANeBuǂ`FbN
#define CheckActiveState()					\
		if( g_AndroidSys.NonActiveRunFlag == FALSE &&\
			( ( g_AndroidSys.ActivityState != DX_ANDR_CMD_START &&\
			  g_AndroidSys.ActivityState != DX_ANDR_CMD_RESUME ) ||\
			  g_AndroidSys.NativeWindow == NULL ) )\
		{\
			DxActiveWait_Android() ;\
		}

// Looper ̃CxgID
#define DX_LOOPER_ID_MAIN							(1)				// CXbh瑗R}hCxg
#define DX_LOOPER_ID_INPUT							(2)				// ̓Cxg
#define DX_LOOPER_ID_SENSOR_ACCELEROMETER			(3)				// xZT[̃Cxg
#define DX_LOOPER_ID_SENSOR_MAGNETIC_FIELD			(4)				// EZT[̃Cxg
#define DX_LOOPER_ID_SENSOR_GYROSCOPE				(5)				// WCXR[vZT[̃Cxg
#define DX_LOOPER_ID_SENSOR_LIGHT					(6)				// ƓxZT[̃Cxg
#define DX_LOOPER_ID_SENSOR_PROXIMITY				(7)				// ߐڃZT[̃Cxg
#define DX_LOOPER_ID_SENSOR_PRESSURE				(8)				// ZT[̃Cxg
#define DX_LOOPER_ID_SENSOR_AMBIENT_TEMPERATURE		(9)				// xZT[̃Cxg

// \tgspXbhɑR}h
#define DX_ANDR_CMD_START							(0)				// onStart Ă΂ꂽ
#define DX_ANDR_CMD_RESUME							(1)				// onResume Ă΂ꂽ
#define DX_ANDR_CMD_PAUSE							(2)				// onPause Ă΂ꂽ
#define DX_ANDR_CMD_STOP							(3)				// onStop Ă΂ꂽ
#define DX_ANDR_CMD_DESTROY							(4)				// onDestroy Ă΂ꂽ
#define DX_ANDR_CMD_GAINED_FOCUS					(5)				// onWindowFocusChanged Ă΂AtH[JXONɂȂ
#define DX_ANDR_CMD_LOST_FOCUS						(6)				// onWindowFocusChanged Ă΂AtH[JXOFFɂȂ
#define DX_ANDR_CMD_WINDOW_CHANGED					(7)				// EChE̕ύX
#define DX_ANDR_CMD_INPUT_CHANGED					(8)				// ̓Cxg󂯎L[̕ύX

// \̒` --------------------------------------------------------------------

struct ANDROID_SENSOR_INFO
{
	const ASensor				*Sensor ;							// ZT[
	ASensorEventQueue			*SensorEventQueue ;					// ZT[CxgL[
	ASensorEvent				SensorEvent ;						// ZT[Cxg
} ;

struct DXLIB_ANDROID_SYSTEMINFO
{
	volatile int				NativeActivityBufferLength ;		// NativeActivity AhXi[pobt@Ɋi[łvf
	volatile int				NativeActivityNum ;					// NativeActivity AhXi[pobt@Ɋi[Ăvf̐
	ANativeActivity				**NativeActivityBuffer ;			// NativeActivity AhXi[pobt@
	ANativeActivity				*NativeActivity ;					// \tg Activity
	pthread_mutex_t				NativeActivityMutex ;				// NativeActivity ANZXp~[ebNX
	ALooper						*Looper ;							// \tg̃Cxgp Looper

	volatile AInputQueue		*InputQueue ;						// ̓Cxg󂯎邽߂̃L[
	volatile AInputQueue		*NewInputQueue ;					// V̓Cxg󂯎邽߂̃L[

	volatile ANativeWindow		*NativeWindow ;						// \tg̃EChE
	volatile ANativeWindow		*NewNativeWindow ;					// V\tg̃EChE

	volatile int				ActivityState ;						// ݂ Activity ̏( DX_APP_CMD_RESUME, DX_APP_CMD_START, DX_APP_CMD_PAUSE, DX_APP_CMD_STOP ̂ꂩ )
	volatile int				DestroyRequested ;					// onDestroy R}h\tgspXbh󂯎ǂ( 1:󂯎  0:󂯎ĂȂ )
	volatile int				DestroyRequestedTime ;				// onDestroy R}h
	volatile int				onDestroyEnd ;						// onDestroy R}h̏Iǂ( 0:IĂȂ  1:I )

	volatile int				MutexLockIndex ;
	pthread_mutex_t				Mutex ;								// CXbhƃ\tgspXbhł݂ɎgpϐANZXɎgp~[ebNX
	pthread_cond_t				Cond ;								// CXbhƃ\tgspXbhł݂̏̎s҂ȂǂɎgpϐ

	volatile int				NonActiveRunFlag ;					// AvANeBuł͂ȂĂs邩ǂ̃tO

	volatile int				MessageRead ;						// CXbh\tgspXbhւ̃bZ[W󂯎pt@CfBXNv^
	volatile int				MessageWrite ;						// CXbh\tgspXbhւ̃bZ[Wݗpt@CfBXNv^

	pthread_t					SoftThread ;						// \tgspXbh
	volatile int				SoftThreadRunning ;					// \tgspXbh̎sJnꂽǂ( 0:JnĂȂ  1:Jnꂽ )
	volatile int				SoftThreadDestroyedStart ;			// \tgspXbh̏IJnǂ( 0:JnĂȂ  1:Jnꂽ )
	volatile int				SoftThreadDestroyed ;				// \tgspXbhIǂ( 0:IĂȂ  1:I )
	volatile int				SoftThreadWait ;					// \tgspXbh҂Ԃǂ( 1:҂  0:s )

	volatile int				SoundAndMoviePause ;				// EChEANeBuɂȂTEhƓ悪ꎞ~Ă邩ǂ( TRUE:ꎞ~Ă  FALSE:ꎞ~ĂȂ )

	volatile void				( *LostFocusCallbackFunction )( void *Data ) ;		// AṽtH[JXꂽۂɌĂ΂R[obN֐
	volatile void				*LostFocusCallbackFunctionData ;					// AṽtH[JXꂽۂɌĂ΂R[obN֐ɓn|C^
	volatile void				( *GainedFocusCallbackFunction )( void *Data ) ;	// AṽtH[JXꂽۂɌĂ΂R[obN֐
	volatile void				*GainedFocusCallbackFunctionData ;					// AṽtH[JXꂽۂɌĂ΂R[obN֐ɓn|C^

	ASensorManager				*SensorManager ;					// ZT[}l[W[
	ANDROID_SENSOR_INFO			SensorInfos[ DX_ANDROID_SENSOR_NUM ] ;	// eZT[̏

	jobject						object_EditText ;					// ͂s߂ EditText
	jobject						object_AlertDialog_Builder ;		// ̓_CAO AlertDialog.Builder
	jobject						object_Dialog ;						// ̓_CAO Dialog
} ;

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

extern DXLIB_ANDROID_SYSTEMINFO g_AndroidSys ;
extern int g_AndroidRunFlag ;

// ֐vg^Cv錾-----------------------------------------------------------

// XN[WcwCuʍWɕϊ
extern int ConvScreenPositionToDxScreenPosition( int ScreenX, int ScreenY, int *DxScreenX, int *DxScreenY ) ;

// ANeBuɂȂ܂ŉȂ
extern void DxActiveWait_Android( void ) ;

#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // __DXSYSTEMANDROID_H__
