// -------------------------------------------------------------------------------
// 
// 		cwCu		vOwb_t@C
// 
// 				Ver 3.18c
// 
// -------------------------------------------------------------------------------

#ifndef __DXMOVIE_H__
#define __DXMOVIE_H__

#include "DxCompileConfig.h"

#ifndef DX_NON_MOVIE

// CN[h ------------------------------------------------------------------
#include "DxHandle.h"
#include "DxBaseImage.h"
#include "DxFile.h"

#ifdef __WINDOWS__
	#include "Windows/DxMovieWin.h"
#endif // __WINDOWS__

#ifdef __psp2__
	#include "PSVita/DxMoviePSVita.h"
#endif // __psp2__

#ifdef __ORBIS__
	#include "PS4/DxMoviePS4.h"
#endif // __ORBIS__

#ifdef __ANDROID__
	#include "Android/DxMovieAndroid.h"
#endif // __ANDROID__

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

// \̒` --------------------------------------------------------------------

// [r[t@C̃I[vɕKvȃO[of[^Z߂
struct OPENMOVIE_GPARAM
{
	int							RightAlphaFlag;					// 摜̉EAt@Ƃ݂Ȃnh쐬邩(TRUE:쐬)
	int							A8R8G8B8Flag ;					// 32bitJ[tH[}bg̓ A8R8G8B8 `ƂĈǂ̃tO
	int							NotUseYUVFormatSurfaceFlag ;	// xtutH[}bg̃T[tFXgpȂǂ
} ;

// Ogg Theora ̃fR[h̏
struct THEORADECODE_INFO
{
	double						FrameRate ;						// Pbԕӂ̃R}
	int							TotalFrame ;					// t[
	int							Width, Height ;					// ƍ
} ;

// [r[OtBbNf[^^
struct MOVIEGRAPH
{
	HANDLEINFO				HandleInfo ;					// nhʃf[^

	int						PlayType ;						// Đ^Cv

#ifndef DX_NON_OGGTHEORA
	int						TheoraFlag ;					// Theora gpĂ邩ǂ̃tO( 1:gpĂ  0:gpĂȂ )
	DWORD_PTR				TheoraHandle ;					// Theora t@Cnh
//	LONGLONG				TheoraPlayTime ;				// ĐJn
	LONGLONG				TheoraPrevTimeCount ;			// Ǒv
	LONGLONG				TheoraPlayNowTime ;				// Đ
	int						TheoraTotalPlayTime ;			// Đ( ~b )
	void *					TheoraStreamData ;				// Xg[pf[^
	int						TheoraStreamDataIsFileImage ;	// Xg[pf[^t@Cɓǂݍ񂾂̂ǂ
	double					TheoraFrameRate ;				// t[[g
	int						TheoraLoopType ;				// [v^Cv( 0:f[^ɍ킹ă[v  1:TEhf[^ɍ킹ă[v )
	int						TheoraSetupGraphHandleImage ;	// 摜\žAOtBbNnh̃ZbgAbvIĂ邩ǂ( TRUE:IĂ  FALSE:IĂȂ )
#ifndef DX_NON_SOUND
	int						TheoraVorbisHandle ;			// VorbispTEhnh
	int						TheoraVorbisFrequency ;			// VorbispTEh̎g
	int						TheoraVorbisTotalTime ;			// VorbisTEhf[^̍Đ( ~b )
#endif // DX_NON_SOUND
	double					TheoraPlaySpeedRate ;			// TheorapĐx
#endif // DX_NON_OGGTHEORA

	RECT					SrcRect ;						// ubN]̓]`

	LONGLONG				RefreshFrame ;					// OXVt[
	int						RefreshTime ;					// OXV

	LONGLONG				StopTime ;						// I^C
	int						SufIsSystemMemory ;				// T[tFXVXeɂꍇsqtd
	int						Width, Height ;					// [r[OtBbÑTCY
	int						RightAlpha ;					// [r[̉EAt@`lƂĈ(TRUE:)
	int						A8R8G8B8Flag ;					// 32bitJ[tH[}bg̓ A8R8G8B8 `ƂĈǂ̃tO
	int						NotUseYUVFormatSurfaceFlag ;	// xtutH[}bg̃T[tFXgpȂǂ
	int						PlayFlag ;						// ĐtO
	int						SysPauseFlag ;					// ꎞ~tO
	int						FirstUpdateFlag ;				// ŏ̃Abvf[gsꂽǂ( TRUE:sꂽ  FALSE:܂ )

	int						YUVFlag ;						// xtu`gpĂ邩ǂ( TRUE:Ă  FALSE:ĂȂ )
	int						SurfaceMode ;					// gpĂT[tFX^Cv

	BASEIMAGE				NowImage ;
	int						NowImageGraphOutAlloc ;			// NowImage  GraphData OŊmۂꂽobt@gpĂ邩ǂ
	int						NowImageUpdateFlag ;			// NowImage ̓eXVꂽǂ̃tO( GetMovieBaseImageToGraph p )
	BASEIMAGE				*UseNowImage ;					// Theora  BASEIMAGE gpĂ\̂ŊÕvO͂gׂ
	int						YGrHandle ;						// YUVJ[Ŷ݂̃OtBbNnh
	int						UVGrHandle ;					// YUVJ[UV݂̂̃OtBbNnh
	int						OverlayDestX, OverlayDestY ;	// Ōɐݒ肳ꂽI[o[CT[tFX̏o͈ʒu
	int						OverlayDestExRate ;				// Ōɐݒ肳ꂽI[o[CT[tFX̏o͔{
	int						OverlayDispFlag ;				// Ōɐݒ肳ꂽI[o[CT[tFX̕\tO
	RECT					OverlaySrcRect, OverlayDestRect ;// ŌɃZbgꂽI[o[C\[X`Əo͋`

	void					( *UpdateFunction )( struct MOVIEGRAPH *Movie, void *Data ) ;		// XVɌĂԃR[obN֐
	void					*UpdateFunctionData ;												// R[obN֐ɓn|C^

	MOVIEGRAPH_PF			PF ;							// ˑ
} ;

// [r[f[^Ǘ\
struct MOVIEGRAPHMANAGE
{
	int						InitializeFlag ;				// tO

	int						RightAlphaFlag ;				// 摜̉EAt@Ƃ݂Ȃnh쐬邩(TRUE:쐬)
	int						A8R8G8B8Flag ;					// 32bitJ[tH[}bg A8R8G8B8 `ƂĈǂ̃tO
	int						NotUseYUVFormatSurfaceFlag ;	// xtutH[}bg̃T[tFXgpȂǂ
} ;

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

extern MOVIEGRAPHMANAGE MovieGraphManageData ;								// ֘Af[^

// ֐vg^Cv錾-----------------------------------------------------------

extern	int		InitializeMovieManage( void ) ;																		// [r[֘ÅǗ̏
extern	int		TerminateMovieManage( void ) ;																		// [r[֘ÅǗ̌n

// OpenMovie ̃O[oϐɃANZXȂo[W
extern	int		OpenMovie_UseGParam(
					OPENMOVIE_GPARAM *GParam,
					const wchar_t *FileName,
					const void *FileImage,
					size_t FileImageSize,
					int *Width,
					int *Height,
					int SurfaceMode,
					int ASyncThread = FALSE ) ;

extern	int		OpenMovie( const wchar_t *FileName, int *Width, int *Height, int SurfaceMode ) ;						// [r[J
extern	int		CloseMovie( int MovieHandle ) ;																		// [r[
extern 	int		PlayMovie_( int MovieHandle, int PlayType = DX_PLAYTYPE_BACK, int SysPlay = 0 ) ;					// [r[̍ĐJn
extern 	int		PauseMovie( int MovieHandle, int SysPause = 0 ) ;													// [r[̍ĐXgbv
extern	int		AddMovieFrame( int MovieHandle, unsigned int FrameNum ) ;											// [r[̃t[i߂A߂Ƃ͏oȂ( [r[~ԂŁA Ogg Theora ̂ݗL )
extern	int		SeekMovie( int MovieHandle, int Time ) ;															// [r[̍Đʒuݒ肷(~bP)
extern	int		SetPlaySpeedRateMovie( int MovieHandle, double SpeedRate ) ;										// [r[̍Đxݒ肷( 1.0 = {  2.0 = Q{ )Aꕔ̃t@CtH[}bĝ݂ŗLȋ@\ł
extern 	int		GetMovieState( int MovieHandle ) ;																	// [r[̍ĐԂ𓾂
extern	int		SetMovieVolume( int Volume, int MovieHandle ) ;														// [r[̃{[Zbg(0`10000)
extern	BASEIMAGE *GetMovieBaseImage( int MovieHandle, int *ImageUpdateFlag, int ImageUpdateFlagSetOnly ) ;			// [r[̊{C[Wf[^擾
extern	int		GetMovieTotalFrame( int MovieHandle ) ;																// [r[̑t[𓾂( Ogg Theora ł̂ݗL )
extern	int		TellMovie( int MovieHandle ) ;																		// [r[̍Đʒu擾(~bP)
extern	int		TellMovieToFrame( int MovieHandle ) ;																// [r[̍Đʒu擾(t[P)
extern	int		SeekMovieToFrame( int MovieHandle, int Frame ) ;													// [r[̍Đʒuݒ肷(t[P)
extern	LONGLONG GetOneFrameTimeMovie( int MovieHandle ) ;															// [r[̂Pt[̎Ԃ𓾂
extern	MOVIEGRAPH *GetMovieData( int MovieHandle ) ;																// [r[OtBbÑf[^擾

extern	int		SetCallbackMovie( int MovieHandle, void ( *Callback )( MOVIEGRAPH *Movie, void *Data ), void *Data );	// [r[̍XVɌĂяoR[obN֐o^
extern	int		UpdateMovie( int MovieHandle, int AlwaysFlag = FALSE ) ;											// [r[̍XVs
extern	int		ReleaseMovieSurface( int MovieHandle ) ;															// [r[ŎgpĂT[tFX̉s

extern	int		DisableMovieAll( void ) ;																			// [r[̍ĐԂ~
extern	int		RestoreMovieAll( void ) ;																			// [r[̍ĐԂĐ

extern 	int		PlayMovieAll( void ) ;																				// ׂẴ[r[OtBbNX^[g
extern 	int		PauseMovieAll( void ) ;																				// ׂẴ[r[OtBbNXgbv

extern	int		InitializeMovieHandle( HANDLEINFO *HandleInfo ) ;													// [r[nh֐
extern	int		TerminateMovieHandle( HANDLEINFO *HandleInfo ) ;													// [r[nȟns֐


// ˑ֐

extern	int		InitializeMovieManage_PF( void ) ;																	// [r[֘ÅǗ̏̊ˑ
extern	int		TerminateMovieManage_PF( void ) ;																	// [r[֘ÅǗ̌n̊ˑ

extern	int		TerminateMovieHandle_PF( HANDLEINFO *HandleInfo ) ;													// [r[nȟns
extern	int		OpenMovie_UseGParam_PF( MOVIEGRAPH * Movie, OPENMOVIE_GPARAM *GParam, const wchar_t *FileName, int *Width, int *Height, int SurfaceMode, int ASyncThread = FALSE ) ;	// OpenMovie ̃O[oϐɃANZXȂo[W̊ˑ
extern 	int		PlayMovie__PF( MOVIEGRAPH * Movie, int PlayType = DX_PLAYTYPE_BACK, int SysPlay = 0 ) ;				// [r[̍ĐJn鏈̊ˑ
extern 	int		PauseMovie_PF( MOVIEGRAPH * Movie, int SysPause = 0 ) ;												// [r[̍ĐXgbv鏈̊ˑ
extern	int		SeekMovie_PF( MOVIEGRAPH * Movie, int Time ) ;														// [r[̍Đʒuݒ肷(~bP)̊ˑ
extern	int		SetPlaySpeedRateMovie_PF( MOVIEGRAPH * Movie, double SpeedRate ) ;									// [r[̍Đxݒ肷( 1.0 = {  2.0 = Q{ )̊ˑ
extern 	int		GetMovieState_PF( MOVIEGRAPH * Movie ) ;															// [r[̍ĐԂ𓾂鏈̊ˑ
extern	int		SetMovieVolume_PF( MOVIEGRAPH * Movie, int Volume ) ;												// [r[̃{[Zbg(0`10000)̊ˑ
extern	BASEIMAGE *GetMovieBaseImage_PF( MOVIEGRAPH * Movie, int *ImageUpdateFlag, int ImageUpdateFlagSetOnly ) ;		// [r[̊{C[Wf[^擾鏈̊ˑ
extern	int		TellMovie_PF( MOVIEGRAPH * Movie ) ;																// [r[̍Đʒu擾(~bP)̊ˑ
extern	int		TellMovieToFrame_PF( MOVIEGRAPH * Movie ) ;															// [r[̍Đʒu擾(t[P)̊ˑ
extern	int		SeekMovieToFrame_PF( MOVIEGRAPH * Movie, int Frame ) ;												// [r[̍Đʒuݒ肷(t[P)̊ˑ
extern	LONGLONG GetOneFrameTimeMovie_PF( MOVIEGRAPH * Movie ) ;													// [r[̂Pt[̎Ԃ𓾂鏈̊ˑ

extern	int		UpdateMovie_PF( MOVIEGRAPH * Movie, int AlwaysFlag = FALSE ) ;										// [r[̍XVs̊ˑ



#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // DX_NON_MOVIE

#endif // __DXMOVIE_H__
